//+------------------------------------------------------------------+
//|                        TrendEnvelopeCOL_DEM_RIB.mq4              |
//+------------------------------------------------------------------+
#property copyright "AHGDP"
#property link      "TrendEnvelopeCOL_DEM_RIB"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 DeepSkyBlue
#property indicator_color2 DeepSkyBlue
#property indicator_color3 DeepSkyBlue  //LimeGreen 
#property indicator_color4 DeepSkyBlue  //LimeGreen 
#property indicator_color5 Magenta 
#property indicator_color6 Magenta 
#property indicator_color7 Magenta   //Red 
#property indicator_color8 Magenta   //Red 

extern int     MA_Per           = 40;
extern int     MA_SiEmSmWe3     = 3 ;

extern int     DEMA_Period      = 21;
extern int     DEMA_Mode        = 1;  
extern int     DEMA_Applied     = PRICE_CLOSE;

extern int     HistoStyle       = 2 ;//0 = soliede strepies
extern int     HistoSize        = 1 ;

extern int     LineStyle        = 2 ;//0
extern int     LineSize         = 2 ;

extern int     CountBars        = 1440 ; 

string         shortName_THTR   = "THTR" ;

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];

double buffer1A[];
double buffer2A[];
double buffer3A[];
double buffer4A[];
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int init()
{  IndicatorDigits (+0);
   IndicatorBuffers(8);
   SetIndexStyle (0, DRAW_HISTOGRAM, HistoStyle, HistoSize);
   SetIndexBuffer(0, buffer3); 
   SetIndexStyle (1, DRAW_HISTOGRAM, HistoStyle, HistoSize);
   SetIndexBuffer(1, buffer4); 
   SetIndexStyle (2, DRAW_LINE, LineStyle, LineSize);
   SetIndexBuffer(2, buffer1);
   SetIndexStyle (3, DRAW_LINE, LineStyle, LineSize);
   SetIndexBuffer(3, buffer2);
   
   SetIndexStyle (4, DRAW_HISTOGRAM, HistoStyle, HistoSize);
   SetIndexBuffer(4, buffer3A); 
   SetIndexStyle (5, DRAW_HISTOGRAM, HistoStyle, HistoSize);
   SetIndexBuffer(5, buffer4A); 
   SetIndexStyle (6, DRAW_LINE, LineStyle, LineSize);
   SetIndexBuffer(6, buffer1A);
   SetIndexStyle (7, DRAW_LINE, LineStyle, LineSize);
   SetIndexBuffer(7, buffer2A);
  
//========================  SHORTNAME  =================================================         
          
             {    string  Text = "(TEDEMR)";
                  Text=Text+"(";
                  Text=Text+""+DoubleToStr(MA_Per,0);
                  Text=Text+"/"+DoubleToStr(MA_SiEmSmWe3,0);
                  Text=Text+"--"+DoubleToStr(DEMA_Period,0);
                  Text=Text+"/"+DoubleToStr(DEMA_Mode,0);
                  Text=Text+")";
                  IndicatorShortName(Text); 
            }   

//===========================================================================     
   return(0);
}
//+------------------------------------------------------------------+                                                       
//+------------------------------------------------------------------+
int deinit()
{
   return(0);
}
//+------------------------------------------------------------------+                                                       
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;

     SetIndexDrawBegin(0,Bars-CountBars);
     SetIndexDrawBegin(1,Bars-CountBars);
     SetIndexDrawBegin(2,Bars-CountBars);
     SetIndexDrawBegin(3,Bars-CountBars);
     
     SetIndexDrawBegin(4,Bars-CountBars);
     SetIndexDrawBegin(5,Bars-CountBars);
     SetIndexDrawBegin(6,Bars-CountBars);
     SetIndexDrawBegin(7,Bars-CountBars);

   for(i=limit; i>=0; i--)
   {
    buffer1[i]  = iCustom(NULL,0,"TrendEnvelopeCOL_DEM",MA_Per,MA_SiEmSmWe3,DEMA_Period ,DEMA_Mode ,DEMA_Applied,0,i);
    buffer2[i]  = iCustom(NULL,0,"TrendEnvelopeCOL_DEM",MA_Per,MA_SiEmSmWe3,DEMA_Period ,DEMA_Mode ,DEMA_Applied,2,i);  
    buffer3[i] = buffer1[i];
    buffer4[i] = buffer2[i];
    }
    for(i=limit; i>=0; i--)
   { 
    buffer1A[i]  = iCustom(NULL,0,"TrendEnvelopeCOL_DEM",MA_Per,MA_SiEmSmWe3,DEMA_Period ,DEMA_Mode ,DEMA_Applied,1,i);
    buffer2A[i]  = iCustom(NULL,0,"TrendEnvelopeCOL_DEM",MA_Per,MA_SiEmSmWe3,DEMA_Period ,DEMA_Mode ,DEMA_Applied,3,i);  
    buffer3A[i] = buffer1A[i];
    buffer4A[i] = buffer2A[i];
    }
    
//===============================================================================================   
   return(0);
   }
//=============================================================================================== 

